apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: application
  name: application

spec:
  replicas: 1
  selector:
    matchLabels:
      app: application
  template:
    metadata:
      labels:
        app: application
    spec:
      containers:
        - image: jamal993/devops:200609-fa1a70ec
          name: devops-app
          env:
            - name: MYSQL_ROOT_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: secret-mysql
                  key: root-password
            - name: MYSQL_DATABASE
              value: assignment
            - name: MYSQL_USER
              valueFrom:
                secretKeyRef:
                  name: secret-mysql
                  key: user-name
            - name: MYSQL_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: secret-mysql
                  key: user-password
            - name: APP_PORT
              value: 8090
          ports:
            - name: http
              containerPort: 8090
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /actuator/health
              port: http
            initialDelaySeconds: 10
            periodSeconds: 5
            timeoutSeconds: 5
            failureThreshold: 100
          readinessProbe:
            httpGet:
              path: /actuator/health
              port: http
            initialDelaySeconds: 10
            periodSeconds: 5
            timeoutSeconds: 5
            failureThreshold: 100
          resources:
            limits:
              cpu: 100m
              memory: 256Mi
      initContainers:
        - image: jamal993/devops-app:mysql-check
          name: mysql-db-check
          volumeMounts:
            - name: check-mysql
              mountPath: /usr/local/test-mysql.sh
              subPath: test-mysql.sh
          env:
            - name: MYSQL_ROOT_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: secret-mysql
                  key: root-password
            - name: MYSQL_DATABASE
              value: assignment
            - name: MYSQL_USER
              value: assignment
            - name: MYSQL_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: secret-mysql
                  key: user-password
          command:
            - sh
            - -c
            - "/usr/local/test-mysql.sh"
      volumes:
        - name: check-mysql
          configMap:
            name: check-mysql
            defaultMode: 0777

